//********************************************************************************
//			
//
//			  CS101 Project for Autumn Semester,2011
//					Batch 611
//				   Sudoku Game & Solver
//
//The sudoku game takes a given sudoku from a file, for the level of difficulty 
//chosen and allows the user to solve it. The solver takes numbers as input 
//from the user and provides a solution.
//
//
//********************************************************************************

#include<iostream>
#include<ezwin.h>
#include "rect.h"
#include<fstream>
#include<cmath>
#include<cstring>
using namespace std;

//Declaring all windows

SimpleWindow s("Sudoku Game",14.0,13.0,Position(7.0,5.0));
SimpleWindow s1("Sudoku Solver",14.0,13.0,Position(7.0,5.0));
SimpleWindow menuwindow("Menu", 5.0, 8.0, Position(10.0, 5.0));
SimpleWindow menu2("Choose Level", 7.0, 10.0, Position(7.0, 5.0));
SimpleWindow congo("Congratulations", 10.0, 6.0, Position(5.0, 7.0));
SimpleWindow highscore("High Scores", 10.0, 10.0, Position(5.0, 5.0));
SimpleWindow sorry("Puzzle not complete", 10.0, 6.0, Position(5.0, 7.0));
SimpleWindow credits("Credits", 8.0, 11.0, Position(7.0, 5.0));
SimpleWindow nosoln("No Possible Solution", 10.0, 6.0, Position(5.0, 7.0));

//Declaring Functions
int is_legal(int row, int col, int val);
int backtrack(int x, int y);

//Declaring all Variables

Position UpperLeft = Position(1.0,11.0);
Position LowerRight = Position(4.0,12.0);
float x, y, m1, n1;
int r, t, i, j, m, n, h, w, lvl, qw, cor, hintcount=0, c=0;
int array[9][9];
string T[]={"01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59","00"};
string Z[]={"00","01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25"};
int test[9][9];
int solve[9][9];
int puzzle[9][9];
char score[17];
bool lvlflag=false;bool flag=false;

//Defining a class for Input from Files

class sudokugenerator
{
	public:
	int sudoku[9][9];
	void setvalue(int temp);
        void getvalue();
};

//Sudoku Solver Function

//test[][] is the original puzzle array which is not to be changed
//solve[][] is the array used for completing the puzzle
//For further details, see Final Project Report

int backtrack(int x, int y) {        //x refers to row and y refers to column //
	int temp,i,j;
	if (solve[x][y] == 0) {
		for (i = 1; i < 10; i++) {
			temp = is_legal(x,y,i);
			if (temp > 0) {
				solve[x][y] = i;
				if (x == 8 && y == 8) {
					return 1;
				} else if (x == 8) {
					if (backtrack(0,y+1)) return 1;
				} else {
					if (backtrack(x+1,y)) return 1 ;
				}
			}
		}
		if (i == 10) {
			if (solve[x][y] != test[x][y]) solve[x][y] = 0;
			return 0;
		}
	} else {
		if (x == 8 && y == 8) {
			return 1;
		} else if (x == 8) {
			if (backtrack(0,y+1)) return 1;
		} else {
			if (backtrack(x+1,y)) return 1;
		}
	}
}

//Input from File
//'temp' is used to signify the difficulty level

void sudokugenerator :: setvalue(int temp)
{
	char str[82]; int a,b,i,j,k=0, count=0;
	
	FILE *fp;
	
	
  	if(temp==1)
     {  srand(time(0));
	b=rand();
	a=b%10+1;

	switch(a)
	{

		case 1 :

		fp=fopen("sudoku1.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 2 :

		fp=fopen("sudoku2.txt","r");
	        fread(str,1,81,fp);
		
		break;

		case 3 :

		fp=fopen("sudoku3.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 4 :

		fp=fopen("sudoku4.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 5 :

		fp=fopen("sudoku5.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 6 :

		fp=fopen("sudoku6.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 7 :

		fp=fopen("sudoku7.txt","r");
		fread(str,1,81,fp);
		
		
		break;

		case 8 :

		fp=fopen("sudoku8.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 9:

		fp=fopen("sudoku9.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 10 :

		fp=fopen("sudoku10.txt","r");
		fread(str,1,81,fp);
	
		default: ;
		

	}
  }
   if(temp==2)
     {   srand(time(0));
	b=rand();
	a=b%10+1;

	switch(a)
	{

		case 1 :

		fp=fopen("sudoku11.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 2 :

		fp=fopen("sudoku12.txt","r");
	        fread(str,1,81,fp);
		
		break;

		case 3 :

		fp=fopen("sudoku13.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 4 :

		fp=fopen("sudoku14.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 5 :

		fp=fopen("sudoku15.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 6 :

		fp=fopen("sudoku16.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 7 :

		fp=fopen("sudoku17.txt","r");
		fread(str,1,81,fp);
		
		
		break;

		case 8 :

		fp=fopen("sudoku18.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 9:

		fp=fopen("sudoku19.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 10 :

		fp=fopen("sudoku20.txt","r");
		fread(str,1,81,fp);
	
		default: ;

	}
}

	if(temp==3)
     {  srand(time(0));
	b=rand();
	a=b%10+1;

	switch(a)
	{

		case 1 :

		fp=fopen("sudoku21.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 2 :

		fp=fopen("sudoku22.txt","r");
	        fread(str,1,81,fp);
		
		break;

		case 3 :

		fp=fopen("sudoku23.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 4 :

		fp=fopen("sudoku24.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 5 :

		fp=fopen("sudoku25.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 6 :

		fp=fopen("sudoku26.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 7 :

		fp=fopen("sudoku27.txt","r");
		fread(str,1,81,fp);
		
		
		break;

		case 8 :

		fp=fopen("sudoku28.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 9:

		fp=fopen("sudoku29.txt","r");
		fread(str,1,81,fp);
		
		break;

		case 10 :

		fp=fopen("sudoku30.txt","r");
		fread(str,1,81,fp);
	
		default: ;

	}
}

        while(count<81)
		{
			count++;
			
 			i=k/9;
 			j=k%9;
 			puzzle[i][j]=str[k] - 48;
  			test[i][j]=puzzle[i][j];
			solve[i][j]=test[i][j];
			array[i][j]=puzzle[i][j];
			k++;
		}
         qw = backtrack (0,0);
		
    

}
/* Used as a Checkpoint

void sudokugenerator :: getvalue()
{  
	int i,j;
	
		
	for (i=0; i<9; i++)
	{
		for(j=0; j<9; j++)
		{
			cout<<puzzle[i][j]<<" ";
		}
		cout<<endl;
	}
}         

*/

//Checker function

int is_legal(int row, int col, int val)
{
	int a = row - row%3;
	int b = col - col%3;
	int i, j, k = 0, res = 1;
	for (i=0; i < 3; ++i)
	{
		for (j=0; j < 3; ++j)
		{ 
			if (solve[a+i][b+j] == val)
			{ 
				return 0;
			}

		}
	}
	for(k=0;k<9;k++)
	{
	if((solve[row][k] == val) || (solve[k][col] == val) )
		{
			return 0;
		}
	}
     return res;
}





//Hint function
//The solver function backtrack is used to solve the given puzzle and then provide hints.

int hint(int hr, int vr)
{
	int e,g,k;

	/* Checkpoint for Solver in Hint

	if (qw ==1)//backtrack(0,0)) 
	{
		for(e=0;e<9;e++)
		{
			for(g=0;g<9;g++)
			{
				cout<<solve[e][g]<<" ";
			}
			cout<<endl;
		}
	}

		*/
        
	int hintno;
	hintno = solve[hr-1][vr-1];
	return hintno;

}

//Checking the solved sudoku game

int correct()
{
	int i,j;
	qw = backtrack (0,0);
	for(i=0; i<9; i++)
	{
		for(j=0; j<9; j++)
		{
			if(array[i][j] != solve[i][j])
			{
				return 0;
 		
			}
		}
	}
	return 1;
}

//Timer function

int showTime()
{
	string T[]={"01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59","00"};
	s.RenderText(Position(12.0, 11.0), Position(13.0, 12.0), T[c],Black, Yellow);
	s.RenderText(Position(11.0, 11.0), Position(13.0, 12.0), ":", Black, Yellow);
	c++;

	if(c==59)
	{
	string Z[]={"00","01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25"};
	s.RenderText(Position(11.0, 11.0), Position(12.0, 12.0), Z[w+1],Black, Yellow);
	c=0;
	w++;
	}
	return 0;
}

//Mouseclick function for the game

int mouse(const Position &p)
{
	Position a; Position b;
	x= p.GetXDistance();
	y= p.GetYDistance();
	r= x/1; t= y/1;
	string A[]= {"1", "2", "3", "4", "5", "6", "7", "8", "9"};

//CLicking in the grid	

	if( r>0 && r<10 && t>0 && t<10)
	{
		m = r; n=t;
		m1= r*1.0; n1= t*1.0;
		s.RenderRectangle(Position(r,t), Position(r+1.0, t+1.0), Green, true);
	}
//Checking if it's a user input

	if( puzzle[n-1][m-1] !=0 )
	{
		s.RenderRectangle(Position(m1, n1), Position(m1+1.0, n1+1.0), Yellow, true);
		s.RenderText(Position(m1,n1), Position(m1+1.0, n1+1.0), A[puzzle[n-1][m-1] - 1], Black, Yellow);
	}

//Clicking on a numbered button

	if(r>0 && r<10 && t>10 && t<12)
	{
		if(puzzle[n-1][m-1] == 0)
		{
			array[n-1][m-1] = r;
			for(i=1; i<=9; i++)
			{
				if(r==i)
				{
					s.RenderRectangle(Position(m1, n1), Position(m1+1.0, n1+1.0), Yellow, true);
					s.RenderText(Position(m1,n1), Position(m1+1.0, n1+1.0), A[i-1], Black, Yellow);
				}
			}
		}
	}

//Clicking on Hint button 
//Hint will only show which number is supposed to be in the selected square

	if(r>10 && r<13 && t>0 && t<2)
	{       
		string A[]= {"1", "2", "3", "4", "5", "6", "7", "8", "9"};
		for(h=1; h<=9; h++)
		{
			if(h==hint(n, m))
			{
				s.RenderRectangle(Position(m1, n1), Position(m1+1.0, n1+1.0), Blue, true);
				s.RenderText(Position(m1, n1), Position(m1+1.0, n1+1.0),A[h-1], White, Blue);					
			}
		}
		hintcount++;	
	}
	s.RenderLine(Position(4.0, 1.0), Position(4.0, 10.0), Black, 0.1);
	s.RenderLine(Position(7.0, 1.0), Position(7.0, 10.0), Black, 0.1);
	s.RenderLine(Position(1.0, 4.0), Position(10.0, 4.0), Black, 0.1);
	s.RenderLine(Position(1.0, 7.0), Position(10.0, 7.0), Black, 0.1);

//Clicking on 'Quit'

	if(r>10 && r<13 && t>8 && t<10)
	{
		s.Close();
		credits.Open();
		credits.RenderRectangle(Position(0.0, 0.0), Position(28.0, 28.0), Black, true);
		credits.RenderText(Position(0.0, 0.0), Position(8.0,4.0), "Created by batch 611, CS101", Yellow, Black);
		credits.RenderText(Position(0.0, 4.0), Position(8.0, 5.0), "Alekhya Audi", White, Black);
		credits.RenderText(Position(0.0, 4.5), Position(8.0, 5.5), "Ajeet Singh", White, Black);
		credits.RenderText(Position(0.0, 5.0), Position(8.0, 6.0), "Archita Dungdung", White, Black);
		credits.RenderText(Position(0.0, 5.5), Position(8.0, 6.5), "Ayush Lakhotia", White, Black);
		credits.RenderText(Position(0.0, 6.0), Position(8.0, 7.0), "Hersh Manek", White, Black);
		credits.RenderText(Position(0.0, 6.5), Position(8.0, 7.5), "Harshit Agrawal", White, Black);
		credits.RenderText(Position(0.0, 7.0), Position(8.0, 8.0), "Ruhee Dcunha", White, Black);
		credits.RenderText(Position(0.0, 8.0), Position(8.0, 9.0), "Thanks to:", Yellow, Black);
		credits.RenderText(Position(0.0, 8.5), Position(8.0, 9.5), "Prof. D. B. Phatak", Yellow, Black);
		credits.RenderText(Position(0.0, 9.0), Position(8.0, 10.0), "Our STA, Srujana Korukoppula", Yellow, Black);
		credits.RenderText(Position(0.0, 9.5), Position(8.0, 10.5), "Our JTA, Debashee Tarai", Yellow, Black);
	}

//CLicking on 'Done'

	if(r>10 && r<13 && t>4 && t<6)
	{  
		credits.Open();
		credits.RenderRectangle(Position(0.0, 0.0), Position(28.0, 28.0), Black, true);
		credits.RenderText(Position(0.0, 0.0), Position(8.0,4.0), "Created by batch 611, CS101", Yellow, Black);
		credits.RenderText(Position(0.0, 4.0), Position(8.0, 5.0), "Alekhya Audi", White, Black);			
		credits.RenderText(Position(0.0, 4.5), Position(8.0, 5.5), "Ajeet Singh", White, Black);
		credits.RenderText(Position(0.0, 5.0), Position(8.0, 6.0), "Archita Dungdung", White, Black);			
		credits.RenderText(Position(0.0, 5.5), Position(8.0, 6.5), "Ayush Lakhotia", White, Black);
		credits.RenderText(Position(0.0, 6.0), Position(8.0, 7.0), "Hersh Manek", White, Black);
		credits.RenderText(Position(0.0, 6.5), Position(8.0, 7.5), "Harshit Agrawal", White, Black);
		credits.RenderText(Position(0.0, 7.0), Position(8.0, 8.0), "Ruhee Dcunha", White, Black);
		credits.RenderText(Position(0.0, 8.0), Position(8.0, 9.0), "Thanks to:", Yellow, Black);
		credits.RenderText(Position(0.0, 8.5), Position(8.0, 9.5), "Prof. D. B. Phatak", Yellow, Black);
		credits.RenderText(Position(0.0, 9.0), Position(8.0, 10.0), "Our STA, Srujana Korukoppula", Yellow, Black);
		credits.RenderText(Position(0.0, 9.5), Position(8.0, 10.5), "Our JTA, Debashee Tarai", Yellow, Black);
		cor = correct();
		if(cor==0)
		{
			sorry.Open();
			s.Close();
			sorry.RenderRectangle(Position(0.0, 0.0), Position(28.0, 28.0), Black, true);
			sorry.RenderText(Position(1.0, 1.0), Position(9.0, 5.0), "Your Sudoku was not solved correctly", Yellow, Black);
			sorry.RenderText(Position(1.0,2.0), Position(9.0, 6.0), "Please try again.", Yellow, Black);
		}
		
		else if (cor==1)
		{      
			congo.Open();
			s.Close();
			congo.RenderRectangle(Position(0.0, 0.0), Position(28.0, 28.0), Black, true);
			congo.RenderText(Position(1.0, 1.0), Position(9.0, 5.0), "Yay, you won!!", Magenta, Black);
			congo.RenderText(Position(1.0, 2.0), Position(5.0, 5.0), "Your time is", Magenta, Black);
			congo.RenderText(Position(4.0, 2.0), Position(7.0, 5.0), Z[w], Magenta, Black);
			congo.RenderText(Position(6.0, 2.0), Position(8.0, 5.0), ":", Magenta, Black);
			congo.RenderText(Position(7.0, 2.0), Position(9.0, 5.0), T[c], Magenta, Black);

//High scores

			int temp2;
			FILE *hs;
			FILE *fpout;
			hs=fopen("highscores.txt","r");
			fread(score,1,17,hs);
			temp2 = 60*w + c + 2 * hintcount;
			if (lvl==1)
			{   
				int temp1,i,j;
				i = score[0]*10 + score[1];
				j = score[3]*10 + score[4];
				temp1 = 60 * i + j;
				if(temp1 >= temp2)
				{
					congo.RenderText(Position(7.0,4.0), Position(9.0,4.0),"High score achieved", Black, Magenta);
					score[0] = w/10;
					score[1] = w%10;
					score[3] = c/10;
					score[4] = c%10;		
				}
				
			}
			if (lvl==2)
			{
				int temp1,i,j;
				i = score[6]*10 + score[7];
				j = score[9]*10 + score[10];
				temp1 = 60 * i + j;
				if(temp1 >= temp2)
				{
					congo.RenderText(Position(7.0,4.0), Position(9.0,4.0),"High score achieved", Black, Magenta);
					score[6] = w/10;
					score[7] = w%10;
					score[9] = c/10;
					score[10] = c%10;		
				}
				
				
			}
			if (lvl==3)
			{
				int temp1,i,j;
				i = score[12]*10 + score[13];
				j = score[15]*10 + score[16];
				temp1 = 60 * i + j;
				if(temp1 >= temp2)
				{
					congo.RenderText(Position(7.0,4.0), Position(9.0,4.0),"High score achieved", Black, Magenta);
					score[12] = w/10;
					score[13] = w%10;
					score[15] = c/10;
					score[16] = c%10;		
				}
				
			}
			fpout = fopen ("highscores.txt", "w");
			fputs(score,fpout);
			fclose(fpout);		
		}
	}

	return 0;
}		

//Mouseclick function for the solver

int mouse1 (const Position &p)
{
	Position a; Position b;
	x= p.GetXDistance();
	y= p.GetYDistance();
	r= x/1; t= y/1;

//Clicking on the grid

	if( r>0 && r<10 && t>0 && t<10)
	{
		m = r; n=t;
		m1= r*1.0; n1= t*1.0;
		s1.RenderLine(Position(4.0, 1.0), Position(4.0, 10.0), Black, 0.1);
		s1.RenderLine(Position(7.0, 1.0), Position(7.0, 10.0), Black, 0.1);
		s1.RenderLine(Position(1.0, 4.0), Position(10.0, 4.0), Black, 0.1);
		s1.RenderLine(Position(1.0, 7.0), Position(10.0, 7.0), Black, 0.1);
		s1.RenderRectangle(Position(r,t), Position(r+1.0, t+1.0), Green, true);
	}
	string A[]= {"1", "2", "3", "4", "5", "6", "7", "8", "9"};

//Clicking on a numbered button

	if(r>0 && r<10 && t>10 && t<12)
	{
		test[n-1][m-1] = r;
		solve[n-1][m-1] = test[n-1][m-1];
		for(i=1; i<=9; i++)
		{
			if(r==i)
			{	
				s1.RenderRectangle(Position(m1, n1), Position(m1+1.0, n1+1.0), Yellow, true);
				s1.RenderText(Position(m1,n1), Position(m1+1.0, n1+1.0), A[i-1], Black, Yellow);
			}	
		}
	}

//Clicking on 'Solve'

	if(r>10 && r<13 && t>1 && t<3)
	{
		int i,j,m,n,o;
		if (backtrack(0,0)) 
		{
			printf("\n") ;
			for (i = 0; i < 9; i++) 
			{
				for (j = 0; j < 9; j++) 
				{
					printf(" %d ", solve[i][j]);
				}
				printf("\n");
				
			}
			Position ul[10];Position lr[10];
			float x,x1,y,y1;
			int r, t;
			Position p1; Position p2; 
			p1=Position(0.0,0.0); p2=Position(28.0, 28.0);
	        	x=1.0;y=1.0;x1=2.0;y1=2.0;
			string D[] ={"1", "2", "3", "4", "5", "6", "7", "8", "9"};
	        	for(int j=0; j<9; j++)
			{
				for(int i=0; i<9; i++)
	        		{
	                		ul[i]=Position(x,y);
	                		lr[i]=Position(x1,y1);
					s1.RenderRectangle(ul[i], lr[i], Yellow, true);
	                		s1.RenderText(ul[i],lr[i], D[solve[j][i]-1], Black, Yellow);
	                		x+=1.0;
	               			x1+=1.0;
					s1.RenderLine(Position(4.0, 1.0), Position(4.0, 10.0), Black, 0.1);
					s1.RenderLine(Position(7.0, 1.0), Position(7.0, 10.0), Black, 0.1);
					s1.RenderLine(Position(1.0, 4.0), Position(10.0, 4.0), Black, 0.1);
					s1.RenderLine(Position(1.0, 7.0), Position(10.0, 7.0), Black, 0.1);
	        		}
			y+=1.0;
			y1+=1.0;
			x=1.0; x1=2.0;
			}
			x=1.0;y=11.0;x1=2.0;y1=12.0;
				
		} 
		else
		{
			nosoln.Open();
			nosoln.RenderRectangle(Position(0.0, 0.0), Position(28.0, 28.0), Black, true);
			nosoln.RenderText(Position(0.0, 0.0), Position(10.0, 6.0), "You have inputed values not following the rules of Sudoku.", White, Black);
			nosoln.RenderText(Position(0.0,1.0), Position(10.0, 7.0), "Please enter the digits again", White , Black);
			
		}

			
	}
	
//CLicking on 'Quit'

	if(r>10 && r<13 && t>5 && t<7)
	{
		s1.Close();
		credits.Open();
		credits.RenderRectangle(Position(0.0, 0.0), Position(28.0, 28.0), Black, true);
		credits.RenderText(Position(0.0, 0.0), Position(8.0,4.0), "Created by batch 611, CS101", Yellow, Black);
		credits.RenderText(Position(0.0, 4.0), Position(8.0, 5.0), "Alekhya Audi", White, Black);
		credits.RenderText(Position(0.0, 4.5), Position(8.0, 5.5), "Ajeet Singh", White, Black);
		credits.RenderText(Position(0.0, 5.0), Position(8.0, 6.0), "Archita Dungdung", White, Black);
		credits.RenderText(Position(0.0, 5.5), Position(8.0, 6.5), "Ayush Lakhotia", White, Black);
		credits.RenderText(Position(0.0, 6.0), Position(8.0, 7.0), "Hersh Manek", White, Black);
		credits.RenderText(Position(0.0, 6.5), Position(8.0, 7.5), "Harshit Agrawal", White, Black);
		credits.RenderText(Position(0.0, 7.0), Position(8.0, 8.0), "Ruhee Dcunha", White, Black);
		credits.RenderText(Position(0.0, 8.0), Position(8.0, 9.0), "Thanks to:", Yellow, Black);
		credits.RenderText(Position(0.0, 8.5), Position(8.0, 9.5), "Prof. D. B. Phatak", Yellow, Black);
		credits.RenderText(Position(0.0, 9.0), Position(8.0, 10.0), "Our STA, Srujana Korukoppula", Yellow, Black);
		credits.RenderText(Position(0.0, 9.5), Position(8.0, 10.5), "Our JTA, Debashee Tarai", Yellow, Black);
	}

	return 0;
}

//Mouseclick Function for Level Window

int level(const Position &p)
{
	x= p.GetXDistance();
	y= p.GetYDistance();
	if(x>2.0 && x<5.0 && y>4.0 && y<5.0)
	{
		lvl=1;
		lvlflag=true;
	}
	if(x>2.0 && x<5.0 && y>6.0 && y<7.0)
	{
		lvl=2;
		lvlflag=true;
	}
	if(x>2.0 && x<5.0 && y>8.0 && y<9.0)
	{
		lvl=3;
		lvlflag=true;
	}
	if(lvlflag)
	{
		sudokugenerator obj;
        	obj.setvalue(lvl);

//To print the original array
//obj.getvalue();

		Position ul[10];Position lr[10];
       		float x,x1,y,y1;
		int r, t;
		Position p1; Position p2; Position pos1; Position pos2; Position pos3;
		p1=Position(0.0,0.0); p2=Position(28.0, 28.0);
		s.Open();
		menu2.Close();
		s.RenderRectangle(p1, p2, Black, true);
    	 	x=1.0;y=1.0;x1=2.0;y1=2.0;
		string L[]= {"1", "2", "3", "4", "5", "6", "7", "8", "9"};
     	 	for(int j=0; j<9; j++)
		{
			for(int i=0; i<9; i++)
        		{
               			ul[i]=Position(x,y);
               			lr[i]=Position(x1,y1);
               			s.RenderRectangle(ul[i],lr[i],Yellow,true);
				if(puzzle[j][i] !=0)
				{
				s.RenderText(ul[i], lr[i], L[puzzle[j][i]-1], Black, Yellow);
				}
               			x+=1.0;
               			x1+=1.0;
        		}
		y+=1.0;
		y1+=1.0;
		x=1.0; x1=2.0;
		}
		x=1.0;y=11.0;x1=2.0;y1=12.0;
		string A[]= {"1", "2", "3", "4", "5", "6", "7", "8", "9"};
		for(int i=0; i<9; i++)
        		{
                		ul[i]=Position(x,y);
                		lr[i]=Position(x1,y1);
				s.RenderRectangle(ul[i], lr[i], Yellow, true);
				s.RenderText(ul[i], lr[i], A[i], Magenta, Yellow);
                		x+=1.0;
                		x1+=1.0;
        		}
		s.RenderLine(Position(4.0, 1.0), Position(4.0, 10.0), Black, 0.1);
		s.RenderLine(Position(7.0, 1.0), Position(7.0, 10.0), Black, 0.1);
		s.RenderLine(Position(1.0, 4.0), Position(10.0, 4.0), Black, 0.1);
		s.RenderLine(Position(1.0, 7.0), Position(10.0, 7.0), Black, 0.1);
		s.RenderRectangle(Position(11.0, 1.0), Position(13.0, 2.0), Red, true);
		s.RenderText(Position(11.0, 1.0), Position(13.0, 2.0), "Hint", Black, Red);
		s.RenderRectangle(Position(11.0, 5.0), Position(13.0, 6.0), Red, true);
		s.RenderText(Position(11.0, 5.0), Position(13.0, 6.0), "Done", Black, Red);
		s.RenderRectangle(Position(11.0, 9.0), Position(13.0, 10.0), Red, true);
		s.RenderText(Position(11.0, 9.0), Position(13.0, 10.0), "Quit", Black, Red);
		s.RenderRectangle(Position(11.0, 11.0), Position(13.0, 12.0), Yellow, true);
		s.SetTimerCallback(showTime);
		s.StartTimer(1000);
		s.SetMouseClickCallback(mouse);
	}
	return 0;
}

//Mouseclick Function for Menu Window

int menubutton(const Position &p)
{	
	x= p.GetXDistance();
	y= p.GetYDistance();
	r= x/1; t= y/1;
	if(r>0 && r<4 && t ==4)
	{
                menuwindow.Close();
		menu2.Open();
		menu2.RenderRectangle(Position(0.0, 0.0), Position(20.0, 20.0), Black, true);
		menu2.RenderRectangle(Position(1.0, 1.0), Position(6.0, 2.0), Red, true);
		menu2.RenderText(Position(0.0, 1.0), Position(7.0, 2.0), "Choose Your Level:", Black, Red);
		menu2.RenderRectangle(Position(2.0, 4.0), Position(5.0, 5.0), Yellow, true);
		menu2.RenderText(Position(2.0, 4.0), Position(5.0, 5.0), "Easy", Black, Yellow);
		menu2.RenderRectangle(Position(2.0, 6.0), Position(5.0, 7.0), Yellow, true);
		menu2.RenderText(Position(2.0, 6.0), Position(5.0, 7.0), "Medium", Black, Yellow);
		menu2.RenderRectangle(Position(2.0, 8.0), Position(5.0, 9.0), Yellow, true);	
		menu2.RenderText(Position(2.0, 8.0), Position(5.0, 9.0), "Hard", Black, Yellow);
		menu2.SetMouseClickCallback(level);
		
	}
	else if(r>0 && r<4 && t==6)
	{
		menuwindow.Close();
		Position ul[10];Position lr[10];
        	float x,x1,y,y1;
		int r, t;
		Position p1; Position p2; 
		p1=Position(0.0,0.0); p2=Position(28.0, 28.0);
		s1.Open();
		s1.RenderRectangle(p1, p2, Black, true);
        	x=1.0;y=1.0;x1=2.0;y1=2.0;
        	for(int j=0; j<9; j++)
		{
			for(int i=0; i<9; i++)
        		{
                		ul[i]=Position(x,y);
                		lr[i]=Position(x1,y1);
                		s1.RenderRectangle(ul[i],lr[i],Yellow,true);
                		x+=1.0;
               			x1+=1.0;
        		}
		y+=1.0;
		y1+=1.0;
		x=1.0; x1=2.0;
		}
		x=1.0;y=11.0;x1=2.0;y1=12.0;
		string A[]= {"1", "2", "3", "4", "5", "6", "7", "8", "9"};
		for(int i=0; i<9; i++)
        		{
                		ul[i]=Position(x,y);
                		lr[i]=Position(x1,y1);
				s1.RenderRectangle(ul[i], lr[i], Yellow, true);
				s1.RenderText(ul[i], lr[i], A[i], Magenta, Yellow);
                		x+=1.0;
                		x1+=1.0;
        		}
		s1.RenderLine(Position(4.0, 1.0), Position(4.0, 10.0), Black, 0.1);
		s1.RenderLine(Position(7.0, 1.0), Position(7.0, 10.0), Black, 0.1);
		s1.RenderLine(Position(1.0, 4.0), Position(10.0, 4.0), Black, 0.1);
		s1.RenderLine(Position(1.0, 7.0), Position(10.0, 7.0), Black, 0.1);	
		s1.RenderRectangle(Position(11.0, 2.0), Position(13.0, 3.0), Red, true);
		s1.RenderText(Position(11.0, 2.0), Position(13.0, 3.0), "Solve", Black, Red);
		s1.RenderRectangle(Position(11.0, 6.0), Position(13.0, 7.0), Red, true);
		s1.RenderText(Position(11.0, 6.0), Position(13.0, 7.0), "Quit", Black, Red);
		s1.SetMouseClickCallback(mouse1);
	}
		return 0;
}



int ApiMain()
{
	menuwindow.Open();
        Position ul[10];Position lr[10];
        float x,x1,y,y1;
	Position p1; Position p2;
	p1=Position(0.0,0.0); p2=Position(28.0, 28.0);
	menuwindow.RenderRectangle(p1, p2, Black, true);
	menuwindow.RenderRectangle(Position(1.0, 4.0), Position(4.0, 5.0), Yellow, true);
	menuwindow.RenderRectangle(Position(1.0, 6.0), Position(4.0, 7.0), Yellow, true);
	menuwindow.RenderRectangle(Position(0.5, 0.5), Position(4.5, 2.5), Blue, true);
	menuwindow.RenderText(Position(0.5, 0.5), Position(4.5, 2.5), "Welcome", White, Blue);
	menuwindow.RenderText(Position(1.0, 4.0), Position(4.0, 5.0), "Sudoku Game", Black, Yellow);
	menuwindow.RenderText(Position(1.0, 6.0), Position(4.0, 7.0), "Sudoku Solver", Black, Yellow);
	menuwindow.SetMouseClickCallback(menubutton);
	
	return 0;
}



